{  $Id: gplprog.pt,v 1.2 2002/09/07 15:40:47 peter Exp 2011/06/16 01:22:26 peter Exp $
    This file is part of Phi's Forza 4
    Copyright (c) 2011 by Andrea Agnolin

    Main Forza 4 file

    See the file COPYING.FPC, included in this distribution,
    for details about the copyright.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 **********************************************************************}
program forza4;
{$apptype GUI}
{$r forza4.rc.res}

uses windows, graph;

const
g1 : smallint = vga;
g2 : smallint = 2;

var
campo    :array[1..7, 1..6] of byte;
hcampo   :array[1..7, 1..6] of hwnd;
i,j,k    :longint;
hbmp     :array[0..2]of hbitmap;
hrs,hend :hwnd;
turno    :byte;
vinte    :array[1..2] of byte;
primo    :byte;

 //Converte intero in stringa
function int2str(n:integer):string;
begin
str(n,int2str);
end;

 // Crea i "Static Control" e i "Button Control"
procedure creando;
const sstile = ws_child or ws_visible or ss_centerimage or ss_bitmap or ss_notify;
const bstile = ws_child or ws_visible;
begin
for i := 1 to 7 do for j := 1 to 6 do
  hcampo[i, j]:=createwindow('Static', '', sstile, 99+60*i, 60*j, 60, 60, graphwindow, 0,hinstance, nil);
hrs :=createwindow('Button', 'Restart',bstile, 15, 420, 70, 20, graphwindow, 0,hinstance, nil);
hend:=createwindow('Button', 'Chiudi', bstile, 15, 445, 70, 20, graphwindow, 0,hinstance, nil);
end;

 //Pulisce il campo e fa iniziare una nuova partita
procedure startgioco(resetall:boolean);
begin
for i := 1 to 7 do for j := 1 to 6 do begin
 campo[i,j]:=0;
 sendmessage(hcampo[i, j],stm_setimage,image_bitmap,hbmp[0]);
end;
if resetall then begin
 primo:=1;
 turno:=1;
 bar3d(10,160,95,175,1,true);
 outtextxy(20,165, 'Giallo');
 bar3d(10,230,95,270,1,true);
 outtextxy(15,240, 'Giallo:0');
 outtextxy(15,255, 'Rosso :0');
 vinte[1]:=0;vinte[2]:=0;
end;
end;

 //Controlla se un giocatore ha vinto o se il campo  pieno
function check:byte;
begin
for i := 1 to 4 do for j := 6 downto 1 do begin
 check:=campo[i,j];
 for k := 1 to 3 do if campo[i+k,j]<>campo[i,j] then check:=0;
 if check<>0 then exit;
end;
for i := 1 to 7 do for j := 3 downto 1 do begin
 check:=campo[i,j];
 for k := 1 to 3 do if campo[i,j+k]<>campo[i,j] then check:=0;
 if check<>0 then exit;
end;
for i := 1 to 4 do for j := 3 downto 1 do begin
 check:=campo[i,j];
 for k := 1 to 3 do if campo[i+k,j+k]<>campo[i,j] then check:=0;
 if check<>0 then exit;
 check:=campo[i,3+j];
 for k := 1 to 3 do if campo[i+k,3+j-k]<>campo[i,3+j] then check:=0;
 if check<>0 then exit;
end;
check:=3;
for i := 1 to 7 do for j := 1 to 6 do if campo[i, j]=0 then check:=0;
if check=3 then exit;
end;

 //Viene eseguita da Windows quando una finestra invia un messaggio alla finestra principale
function wmcommand(wnd, msg: longword; wp, lp : longint) : longint; stdcall;
var t, c : byte;
begin
t := 0;
if lp = hrs then startgioco(true);
if lp = hend then halt(0);
for i := 1 to 7 do for j := 1 to 6 do
 if hcampo[i, j]=lp then begin
  t:=i;
  continue;
 end;
if t <> 0 then begin
 i := 6;
 while (campo[t, i]<>0) and (i<>0) do dec(i);
 if i=0 then exit else begin
  campo[t, i]:=turno;
  turno:=3-turno;
  sendmessage(hcampo[t, i],stm_setimage,image_bitmap,hbmp[campo[t, i]]);
  c := check;
  if c=3 then begin
   messagebox(wnd,'Campo pieno','Gioco',0);
   startgioco(false);
   primo:=3-primo;
   turno:=primo;
  end;
  if (c=2) or (c=1) then begin
   inc(vinte[c]);
   primo:=3-primo;
   turno:=primo;
   if c=1 then messagebox(wnd,'Vince Giallo','Gioco',0)
    else messagebox(wnd,'Vince Rosso','Gioco',0);
   startgioco(false);
  end;
  bar3d(10,160,95,175,1,true);
  if turno = 1 then outtextxy(20,165, 'Giallo') else outtextxy(20,165, 'Rosso');
  bar3d(10,230,95,270,1,true);
  outtextxy(15,240, concat('Giallo:',int2str(vinte[1])));
  outtextxy(15,255, concat('Rosse :',int2str(vinte[2])));
 end;
end;
end;

 //Inizio
procedure init;
begin
for i := 0 to 2 do hbmp[i]:=loadbitmap(hinstance,pchar(i));
graph.windowtitle:='Forza 4 - Connect 4';
graph.icon:=loadicon(hinstance, 'Forza4');
graph.ongraphwindowcreation:=@creando;
graph.commandmessagehandler:=@wmcommand;
end;

 //Fine
procedure chiudi;
begin
for i := 0 to 2 do deleteobject(hbmp[i]);
end;

 //Disegna la schermata
procedure disegno;
const
 cend  :array[1..3] of byte=($0b, $68, $d7);
begin
setcolor(0);
for i := 1 to 60 do begin
 setrgbpalette(0,trunc(i*cend[1]/60),trunc(i*cend[2]/60),trunc(i*cend[3]/60));
 rectangle(99+i, i, 639-i, 479-i);
end;
setrgbpalette(0,0,0,0);
setcolor(15);
drawicon(bitmapdc,30,15,graph.icon);
drawicon(windc   ,30,15,graph.icon);
outtextxy(22,60, 'FORZA 4');
setfillstyle(solidfill,0);
outtextxy(5,140, 'Tocca a :');
outtextxy(5,210, 'Punti :');
end;

// MAIN //

BEGIN
init;
initgraph(g1,g2,'');
disegno;
startgioco(true);
while iswindow(graphwindow) do sleep(10);
chiudi;
END.
